<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class ConfirmaEnderecoFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function searchCountry($pais, $paisSemAcento){
        
        $queryConfirmCountry = "SELECT NMPAIS
                        FROM PAIS
                       WHERE (UPPER(NMPAIS) = UPPER('$pais') OR 
                         UPPER(NMPAIS) = UPPER('$paisSemAcento')) ";   
                         
        try {
            $std = $this->connection->prepare($queryConfirmCountry);
            $std->execute();
            $returnedCountry = $std->fetchAll();
            
        } catch (\Exception $e) {
            throw $e;
        }
        
        if(empty($returnedCountry)){
            return array();
        }else{
            return $returnedCountry[0]['NMPAIS'];
        }
    }
    
    public function searchState($estado, $estadoSemAcento, $cdpais){
        
        $queryConfirmState = "SELECT NMESTADO
                        FROM ESTADO
                       WHERE (UPPER(NMESTADO) = UPPER('$estado') OR 
                         UPPER(NMESTADO) = UPPER('$estadoSemAcento'))
                        AND CDPAIS = '$cdpais'";   
                         
        try {
            $std = $this->connection->prepare($queryConfirmState);
            $std->execute();
            $returnedState = $std->fetchAll();
            
        } catch (\Exception $e){
            throw $e;
        }
        
        if(empty($returnedState)){
            return array();
        } else {
            return $returnedState[0]['NMESTADO'];
        }
    }
    
    public function searchCity($municipio, $municipioSemAcento, $cdpais, $sgestado){
        
        $queryConfirmCity = "SELECT NMMUNICIPIO
                        FROM MUNICIPIO
                       WHERE (UPPER(NMMUNICIPIO) = UPPER('$municipio') OR 
                         UPPER(NMMUNICIPIO) = UPPER('$municipioSemAcento')) 
                        AND CDPAIS   = '$cdpais' 
                        AND SGESTADO = '$sgestado' ";   
        try {
            $std = $this->connection->prepare($queryConfirmCity);
            $std->execute();
            $returnedCity = $std->fetchAll();
            
        } catch (\Exception $e){
            throw $e;
        }
        
        if(empty($returnedCity)){
            return array();
        } else {
            return $returnedCity[0]['NMMUNICIPIO'];
        }
    }
    
    public function searchNeigh($bairro, $bairroSemAcento, $cdpais, $sgestado, $cdmunicipio){
        
        $queryConfirmNeigh = "SELECT NMBAIRRO,
                        CDBAIRRO
                        FROM BAIRRO
                       WHERE (UPPER(NMBAIRRO) = UPPER('$bairro') OR 
                         UPPER(NMBAIRRO) = UPPER('$bairroSemAcento')) 
                        AND CDPAIS      = '$cdpais' 
                        AND SGESTADO    = '$sgestado' 
                        AND CDMUNICIPIO = '$cdmunicipio'";
                         
        try {
            $std = $this->connection->prepare($queryConfirmNeigh);
            $std->execute();
            $returnedNeigh = $std->fetchAll();
            
        } catch (\Exception $e){
            throw $e;
        }
        
        if(empty($returnedNeigh)){
            return array();
        } else {
            return $returnedNeigh[0];
        }
    }
    
    public function inserirBairro(array $params) {
        $sql = "INSERT INTO BAIRRO (
                    CDPAIS,         SGESTADO,       CDMUNICIPIO,
                    CDBAIRRO,       NMBAIRRO,       IDATIVO,
                    NRORG,          DTINCLUSAO,     CDOPERINCLUSAO,
                    NRORGINCLUSAO
                )
                VALUES (
                    :CDPAIS,        :SGESTADO,      :CDMUNICIPIO,
                    :CDBAIRRO,      :NMBAIRRO,      :IDATIVO,
                    :NRORG,         SYSDATE,        :CDOPERINCLUSAO,
                    :NRORGINCLUSAO
                )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
  
}